#ifndef SOCKET_H
#define SOCKET_H

#include <sys/socket.h>
#include <netinet/in.h>
#include <string>

class InAddr {
public:
  virtual ~InAddr() { };
  virtual void set_port(int port)=0;
  static InAddr *resolv(const char *name);
  virtual string tostring() = 0;
  virtual sockaddr * addr()=0;
  virtual socklen_t addr_len() = 0;
  virtual int af()=0;
};

class Socket {
  int fd;
  struct sockaddr_in address;
  bool dead;
  string buffer;
 public:
  bool getdead() { return dead; }
  Socket();
  int connect(InAddr *where);
  int read(char *, int);
  int write(const char *, int);
  void close();
  virtual ~Socket();
  int getfd() { return fd; }
};

#endif
